/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Settings.xs. Do not edit this file, edit Settings.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Settings.xs"
#include "module.h"
#include "misc.h"
#include "recode.h"

static GHashTable *perl_settings;

static void perl_settings_add(const char *key)
{
	PERL_SCRIPT_REC *script;
        GSList *list;

	script = perl_script_find_package(perl_get_package());
	g_return_if_fail(script != NULL);

	list = g_hash_table_lookup(perl_settings, script);
        list = g_slist_append(list, g_strdup(key));
	g_hash_table_insert(perl_settings, script, list);
}

static void perl_settings_remove(const char *key)
{
	PERL_SCRIPT_REC *script;
        GSList *list, *pos;

	script = perl_script_find_package(perl_get_package());
	g_return_if_fail(script != NULL);

	list = g_hash_table_lookup(perl_settings, script);
	pos = gslist_find_icase_string(list, key);
	if (pos != NULL) {
		list = g_slist_remove(list, pos->data);
		g_hash_table_insert(perl_settings, script, list);
	}
}

static void perl_settings_free(PERL_SCRIPT_REC *script, GSList *list)
{
	g_slist_foreach(list, (GFunc) g_free, NULL);
        g_slist_free(list);
}

static void sig_script_destroyed(PERL_SCRIPT_REC *script)
{
	GSList *list;

	list = g_hash_table_lookup(perl_settings, script);
	if (list != NULL) {
                g_slist_foreach(list, (GFunc) settings_remove, NULL);
		perl_settings_free(script, list);
		g_hash_table_remove(perl_settings, script);
	}
}

void perl_settings_init(void)
{
	perl_settings = g_hash_table_new((GHashFunc) g_direct_hash,
					 (GCompareFunc) g_direct_equal);
        signal_add("script destroyed", (SIGNAL_FUNC) sig_script_destroyed);
}

void perl_settings_deinit(void)
{
        signal_remove("script destroyed", (SIGNAL_FUNC) sig_script_destroyed);

	g_hash_table_foreach(perl_settings, (GHFunc) perl_settings_free, NULL);
	g_hash_table_destroy(perl_settings);
}

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 83 "Settings.c"

XS(XS_Irssi_settings_get_str); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_get_str)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_get_str", "key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
#line 76 "Settings.xs"
	const char *str;
#line 100 "Settings.c"
	SV *	RETVAL;
#line 78 "Settings.xs"
	str = settings_get_str(key);
	RETVAL = new_pv(str);
	if (is_utf8())
		SvUTF8_on(RETVAL);
#line 107 "Settings.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Irssi_settings_get_int); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_get_int)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_get_int", "key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	int	RETVAL;
	dXSTARG;

	RETVAL = settings_get_int(key);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Irssi_settings_get_bool); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_get_bool)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_get_bool", "key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	int	RETVAL;
	dXSTARG;

	RETVAL = settings_get_bool(key);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Irssi_settings_get_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_get_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_get_time", "key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	int	RETVAL;
	dXSTARG;

	RETVAL = settings_get_time(key);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Irssi_settings_get_level); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_get_level)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_get_level", "key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	int	RETVAL;
	dXSTARG;

	RETVAL = settings_get_level(key);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Irssi_settings_get_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_get_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_get_size", "key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	int	RETVAL;
	dXSTARG;

	RETVAL = settings_get_size(key);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Irssi_settings_set_str); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_set_str)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_set_str", "key, value");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	char *	value = (char *)SvPV_nolen(ST(1));

	settings_set_str(key, value);
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_settings_set_int); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_set_int)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_set_int", "key, value");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	int	value = (int)SvIV(ST(1));

	settings_set_int(key, value);
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_settings_set_bool); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_set_bool)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_set_bool", "key, value");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	int	value = (int)SvIV(ST(1));

	settings_set_bool(key, value);
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_settings_set_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_set_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_set_time", "key, value");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	char *	value = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = settings_set_time(key, value);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Irssi_settings_set_level); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_set_level)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_set_level", "key, value");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	char *	value = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = settings_set_level(key, value);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Irssi_settings_set_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_set_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_set_size", "key, value");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
	char *	value = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = settings_set_size(key, value);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Irssi_settings_add_str); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_add_str)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_add_str", "section, key, def");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	section = (char *)SvPV_nolen(ST(0));
	char *	key = (char *)SvPV_nolen(ST(1));
	char *	def = (char *)SvPV_nolen(ST(2));
#line 141 "Settings.xs"
        perl_settings_add(key);
	settings_add_str_module(MODULE_NAME"/scripts", section, key, def);
#line 383 "Settings.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_settings_add_int); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_add_int)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_add_int", "section, key, def");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	section = (char *)SvPV_nolen(ST(0));
	char *	key = (char *)SvPV_nolen(ST(1));
	int	def = (int)SvIV(ST(2));
#line 150 "Settings.xs"
        perl_settings_add(key);
	settings_add_int_module(MODULE_NAME"/scripts", section, key, def);
#line 407 "Settings.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_settings_add_bool); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_add_bool)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_add_bool", "section, key, def");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	section = (char *)SvPV_nolen(ST(0));
	char *	key = (char *)SvPV_nolen(ST(1));
	int	def = (int)SvIV(ST(2));
#line 159 "Settings.xs"
        perl_settings_add(key);
	settings_add_bool_module(MODULE_NAME"/scripts", section, key, def);
#line 431 "Settings.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_settings_add_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_add_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_add_time", "section, key, def");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	section = (char *)SvPV_nolen(ST(0));
	char *	key = (char *)SvPV_nolen(ST(1));
	char *	def = (char *)SvPV_nolen(ST(2));
#line 168 "Settings.xs"
        perl_settings_add(key);
	settings_add_time_module(MODULE_NAME"/scripts", section, key, def);
#line 455 "Settings.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_settings_add_level); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_add_level)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_add_level", "section, key, def");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	section = (char *)SvPV_nolen(ST(0));
	char *	key = (char *)SvPV_nolen(ST(1));
	char *	def = (char *)SvPV_nolen(ST(2));
#line 177 "Settings.xs"
        perl_settings_add(key);
	settings_add_level_module(MODULE_NAME"/scripts", section, key, def);
#line 479 "Settings.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_settings_add_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_add_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_add_size", "section, key, def");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	section = (char *)SvPV_nolen(ST(0));
	char *	key = (char *)SvPV_nolen(ST(1));
	char *	def = (char *)SvPV_nolen(ST(2));
#line 186 "Settings.xs"
        perl_settings_add(key);
	settings_add_size_module(MODULE_NAME"/scripts", section, key, def);
#line 503 "Settings.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_settings_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_settings_remove)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Irssi::settings_remove", "key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	key = (char *)SvPV_nolen(ST(0));
#line 193 "Settings.xs"
        perl_settings_remove(key);
	settings_remove(key);
#line 525 "Settings.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Irssi__Settings); /* prototype to pass -Wmissing-prototypes */
XS(boot_Irssi__Settings)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Irssi::settings_get_str", XS_Irssi_settings_get_str, file, "$");
        newXSproto("Irssi::settings_get_int", XS_Irssi_settings_get_int, file, "$");
        newXSproto("Irssi::settings_get_bool", XS_Irssi_settings_get_bool, file, "$");
        newXSproto("Irssi::settings_get_time", XS_Irssi_settings_get_time, file, "$");
        newXSproto("Irssi::settings_get_level", XS_Irssi_settings_get_level, file, "$");
        newXSproto("Irssi::settings_get_size", XS_Irssi_settings_get_size, file, "$");
        newXSproto("Irssi::settings_set_str", XS_Irssi_settings_set_str, file, "$$");
        newXSproto("Irssi::settings_set_int", XS_Irssi_settings_set_int, file, "$$");
        newXSproto("Irssi::settings_set_bool", XS_Irssi_settings_set_bool, file, "$$");
        newXSproto("Irssi::settings_set_time", XS_Irssi_settings_set_time, file, "$$");
        newXSproto("Irssi::settings_set_level", XS_Irssi_settings_set_level, file, "$$");
        newXSproto("Irssi::settings_set_size", XS_Irssi_settings_set_size, file, "$$");
        newXSproto("Irssi::settings_add_str", XS_Irssi_settings_add_str, file, "$$$");
        newXSproto("Irssi::settings_add_int", XS_Irssi_settings_add_int, file, "$$$");
        newXSproto("Irssi::settings_add_bool", XS_Irssi_settings_add_bool, file, "$$$");
        newXSproto("Irssi::settings_add_time", XS_Irssi_settings_add_time, file, "$$$");
        newXSproto("Irssi::settings_add_level", XS_Irssi_settings_add_level, file, "$$$");
        newXSproto("Irssi::settings_add_size", XS_Irssi_settings_add_size, file, "$$$");
        newXSproto("Irssi::settings_remove", XS_Irssi_settings_remove, file, "$");
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

